



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>关于Object类下所有方法的简单解析</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">关于Object类下所有方法的简单解析</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-09 09:54:53 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>类Object是类层次结构的根类，是每一个类的父类，所有的对象包括数组，String，Integer等包装类，所以了解Object是很有必要的，话不多说，我们直接来看jdk的源码，开始我们的分析之路</p>
<p>1.hashcode()</p>
<p>public native int hashCode();//native说明跟机器有关，跟对象的地址有关</p>
<p>如果我们新建一个类，而hashcode没有被重写的话，那么hashcode返回的值只于对象的地址有关，如果hashcode被重写了，那么就另当别论了，但是如果我们重写了equals()的话，那么hashcode(),一定要重写，至于为什么要重写的话，请参考我这篇博客：<a href="http://www.cnblogs.com/yinbiao/p/8110196.html" rel="external nofollow noreferrer">http://www.cnblogs.com/yinbiao/p/8110196.html</a></p>
<p>现在我们来看一下JDk API文档里面关于hashcode的说明</p>
<p><code>hashCode</code> 的常规协定是：</p>
<ul><li>在 Java 应用程序执行期间，在对同一对象多次调用 <tt>hashCode</tt> 方法时，必须一致地返回相同的整数，前提是将对象进行 <tt>equals</tt> 比较时所用的信息没有被修改。从某一应用程序的一次执行到同一应用程序的另一次执行，该整数无需保持一致。</li>
<li>如果根据 <tt>equals(Object)</tt> 方法，两个对象是相等的，那么对这两个对象中的每个对象调用 <code>hashCode</code> 方法都必须生成相同的整数结果。</li>
<li>如果根据 <a href="http://www.cnblogs.com/java/lang/Object.html#equals(java.lang.Object)" rel="external nofollow noreferrer"><code>equals(java.lang.Object)</code></a> 方法，两个对象不相等，那么对这两个对象中的任一对象上调用 <tt>hashCode</tt> 方法<em>不</em> 要求一定生成不同的整数结果。但是，程序员应该意识到，为不相等的对象生成不同整数结果可以提高哈希表的性能。</li></ul>
<p>2.equals()</p>
<p>public boolean equals(Object obj) {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return (this == obj);<br />&nbsp;&nbsp;&nbsp; }</p>
<p>可以看到如果equals()如果没有被重写的话，比较的是对象的地址，String，Integer等包装类里面都重写了该方法，例如String类的equals()方法是比较对象的内容，也就是字符串的，而不是地址</p>
<p>JDK API文档对equals()说明如下：</p>
<p><code>equals</code> 方法在非空对象引用上实现相等关系：</p>
<ul><li><em>自反性</em>：对于任何非空引用值 <code>x</code>，<code>x.equals(x)</code> 都应返回 <code>true</code>。</li>
<li><em>对称性</em>：对于任何非空引用值 <code>x</code> 和 <code>y</code>，当且仅当 <code>y.equals(x)</code> 返回 <code>true</code> 时，<code>x.equals(y)</code> 才应返回 <code>true</code>。</li>
<li><em>传递性</em>：对于任何非空引用值 <code>x</code>、<code>y</code> 和 <code>z</code>，如果 <code>x.equals(y)</code> 返回 <code>true</code>，并且 <code>y.equals(z)</code> 返回 <code>true</code>，那么 <code>x.equals(z)</code> 应返回 <code>true</code>。</li>
<li><em>一致性</em>：对于任何非空引用值 <code>x</code> 和 <code>y</code>，多次调用 <tt>x.equals(y)</tt> 始终返回 <code>true</code> 或始终返回 <code>false</code>，前提是对象上 <code>equals</code> 比较中所用的信息没有被修改。</li>
<li>对于任何非空引用值 <code>x</code>，<code>x.equals(null)</code> 都应返回 <code>false</code></li></ul>
<p>同时这些性质也是我们在重写equals()需要满足的要求</p>
<p>3.getClass()</p>
<p>我们先来看一下JDK API文档对getclass的说明：</p>
<p>返回此 <code>Object</code> 的运行时类。返回的 <code>Class</code> 对象是由所表示类的 <code>static synchronized</code> 方法锁定的对象。</p>
<p>再看一下源码：</p>
<p>public final Class&lt;?&gt; getClass() {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return shadow$_klass_;    }</p>
<p>注意到final关键字，说明这个方法是不能被Object的子类重写的，我们在类中调用的getclass()方法都是调用的Object下面的，且文档对此的说明是返回运行时的对象，举个栗子：</p>
<div>
<pre class="prettyprint linenums"> 1 import java.util.Date;<br />
 2 public&nbsp; class Test extends Date<br />
 3 {<br />
 4 &nbsp; &nbsp; &nbsp; public void test()<br />
 5 &nbsp; &nbsp; &nbsp; {<br />
 6 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; System.out.println(super.getClass().getName());<br />
 7 &nbsp; &nbsp; &nbsp; }<br />
 8 &nbsp; &nbsp; &nbsp; public static void main(String[] args)&nbsp;<br />
 9 &nbsp; &nbsp; &nbsp; {<br />
10 &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; &nbsp; new Test().test();<br />
11 &nbsp; &nbsp; &nbsp; }<br />
12 }</pre>
</div>
<p>输出：Test</p>
<p>有没有觉得很奇怪？输出的竟然是Test，其实一点也不奇怪，我们调用的getClass()是Object的，且它不能被重写，返回的是类运行时的对象，在代码中运行时的类是Test，虽然Test继承与Date，但是如果我们想返回的是Date类，那么我们运行时的对象应该是Date：Date date = &nbsp;new Date();，现在运行时的类就是Date，返回的就是Date。</p>
<p>那么现在又有一个问题，getClass()和getName(),好像他们的输出值都是一样的，那是不是他们就没有区别呢？不是的，话不多说，直接撸源码：</p>
<p><code>public</code>&nbsp;<code>String&nbsp;getName()&nbsp;{</code></p>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code>&nbsp;<code>(name&nbsp;==&nbsp;</code><code>null</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>name&nbsp;=&nbsp;getName0();</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>return</code>&nbsp;<code>name;</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>
<div><code>public</code>&nbsp;<code>final</code>&nbsp;<code>native</code>&nbsp;<code>Class&lt;?&gt;&nbsp;getClass();</code></div>
</div>
<p>getClass()返回的是一个对象，而getName返回的是一个字符串，虽然他们输出都是一样，但是我们必须知道控制台输出任何对象，非基础类型都会转化为字符串输出，所以二者的输出虽然看上去是一样的，但是有很大的区别</p>
<p>4.clone()</p>
<p>JDK API文档对说明：</p>
<p>创建并返回此对象的一个副本。&ldquo;副本&rdquo;的准确含义可能依赖于对象的类。这样做的目的是，对于任何对象 <tt>x</tt>，表达式：</p>
<blockquote><pre class="prettyprint linenums">x.clone() != x</pre></blockquote>
<p>为 true，表达式：</p>
<blockquote><pre class="prettyprint linenums">x.clone().getClass() == x.getClass()</pre></blockquote>
<p>也为 <tt>true</tt>，但这些并非必须要满足的要求。一般情况下：</p>
<blockquote><pre class="prettyprint linenums">x.clone().equals(x)</pre></blockquote>
<p>为 <tt>true</tt>，但这并非必须要满足的要求。</p>
<p>我们再来看看源码：</p>
<p>protected native Object clone() throws CloneNotSupportedException;</p>
<p>我的理解是clone()就是将这个对象重新复制一遍，变成两个对象，都有着自己的内存空间，而不是只建立一个引用，指向同一片内存空间，注意到x.clone() != x，说明二者是两个对象，二者的内存空间都是不同的，所以将二者的地址进行比较的时候，肯定是不相等的，注意到x.clone().getClass() == x.getClass()，说明二者运行时的类都是相同的，注意到x.clone().equals(x)，虽然不要求一定使这个等式为True，但是一般情况下都是成立的，比如String包装类，就是说明这二者的字符串是一样的，但是如果是自定义类等其他类且equals()没有被重写的话，那么这个等式是不成立的，因为equals()没有被重写，那么使用的就是Object下的equals()，比较的是对象的地址，所以等式不成立</p>
<p>那么为什么要有clone()呢？</p>
<p>我们现在先看一下clone()与=的区别，举个栗子：</p>
<p>有一个Car类<br />Car c1 = new Car();<br />Car c2 = c1;<br />这两句事实上只创建了一个对象。只不过c1和c2指向了同一个对象。<br />如果上面的两句改为：<br />Car c1 = new Car();<br />Car c2 = c1.clone();<br />那么就有了两个对象，而且这两个对象的内容是一样的。（所有的属性值相同）</p>
<p>假如现在我们有一个类，它有100个属性，那么我们如果这样：a.name=b.name;这样的话我们需要进行100此操作，这样也太不艺术了。。。。，所以我们就有了clone()方法，所有操作一次性完成！</p>
<p>那么我们现在来看一下clone的具体操作：</p>
<p>要知道我们的java语言取消了指针这个东东，导致了很多人都忽略了对象和引用的区别，java不能通过简单的赋值来解决对象的复制问题</p>
<p>看看下面这个栗子也可以解释我们为什么要有clone()</p>
<div>
<pre class="prettyprint linenums"> 1 &nbsp;A&nbsp;a1=new&nbsp;A();&nbsp;&nbsp;&nbsp;&nbsp;<br />
 2&nbsp;&nbsp;A&nbsp;a2=new&nbsp;A();&nbsp;&nbsp;&nbsp;&nbsp;<br />
 3 &nbsp;a1.name="a1";&nbsp;&nbsp;&nbsp;&nbsp;<br />
 4&nbsp;&nbsp;a2=a1;&nbsp;&nbsp;&nbsp;&nbsp;<br />
 5&nbsp;&nbsp;a2.name="a2";&nbsp;&nbsp;&nbsp;&nbsp;<br />
 6&nbsp;&nbsp;System.out.println("a1.name="+a1.name);&nbsp;&nbsp;&nbsp;&nbsp;<br />
 7&nbsp;&nbsp;System.out.println("a2.name="+a2.name);&nbsp;&nbsp;&nbsp;&nbsp;<br />
 8  //此时输出的结果是：&nbsp;&nbsp;<br />
 9 &nbsp;//a1.name=a2&nbsp;&nbsp;&nbsp;&nbsp;<br />
10 &nbsp;//a2.name=a2&nbsp;&nbsp;&nbsp;&nbsp;</pre>
</div>
<p>如果我们要用a2保存a1对象的数据，但又不希望a2对象数据被改变时不影响到a1。实现clone（）方法是其一种最简单，也是最高效的手段。下面我们来看看clone的分类</p>
<p>浅层clone()：用于类属性只有Java基本类型和String类型的时候</p>
<p>深层clone：当类属性有数组和复杂类型的时候</p>
<p>彻底clone：当类属性有更加复杂的类型的时候，比如Vector对象容器</p>
<p>下面我们用栗子来进行说明：</p>
<p>浅层复制</p>
<div>
<pre class="prettyprint linenums"> package test;

 public class A implements Cloneable{<br />
         public String name;<br />
         public Object clone() {<br />
             A obj = null;<br />
             try {<br />
                 obj = (A)super.clone();<br />
             } catch (CloneNotSupportedException e) {<br />
                 // TODO Auto-generated catch block<br />
                 e.printStackTrace();<br />
             }<br />
             return obj;<br />
         }

     public static void main(String[] args) {<br />
         // TODO Auto-generated method stub<br />
         A a1 = new A();<br />
         A a2 = new A();<br />
         a1.name="a1";<br />
         a2 = (A) a1.clone();<br />
         a2.name = "a2";<br />
         System.out.println("a1.name="+a1.name);<br />
         System.out.println("a2.name="+a2.name);<br />
     }<br />
     /*<br />
      * 结果：<br />
      * a1.name=a1<br />
      * a2.name=a2<br />
      */<br />
 }</pre>
</div>
<p>这就是所谓的浅层复制，我们可以看到我们的name是字符串型的，如果我们的name是字符串数组类型的，仍然用浅层复制，那么又会有什么问题呢？看看下面的栗子：</p>
<div>
<pre class="prettyprint linenums"> package test;

 public class A implements Cloneable{<br />
         public String name[];<br />
         public A() {<br />
             name = new String[2];<br />
         }<br />
         public Object clone() {<br />
             A obj = null;<br />
             try {<br />
                 obj = (A)super.clone();<br />
             } catch (CloneNotSupportedException e) {<br />
                 // TODO Auto-generated catch block<br />
                 e.printStackTrace();<br />
             }<br />
             return obj;<br />
         }

     public static void main(String[] args) {<br />
         // TODO Auto-generated method stub<br />
         A a1 = new A();<br />
         A a2 = new A();<br />
         a1.name[0]="a";<br />
         a1.name[1]="1";<br />
         a2=(A)a1.clone();<br />
         a2.name[0]="b";<br />
         a2.name[1]="1";<br />
         System.out.println("a1.name="+a1.name);<br />
         System.out.println("a1.name="+a1.name[0]+a1.name[1]);<br />
         System.out.println("a2.name="+a2.name);<br />
         System.out.println("a2.name="+a2.name[0]+a2.name[1]);<br />
         /*<br />
          * 结果：<br />
          *  a1.name=[Ljava.lang.String;@7852e922<br />
          *  a1.name=a1<br />
          *  a2.name=[Ljava.lang.String;@4e25154f<br />
          *  a2.name=a2<br />
          */<br />
         /*分析：<br />
          * 可以看到我们的a1.name输出的是name数组的地址<br />
          * 且输出的a1.name和a2.name都是b1,说明在进行对象复制的时候对name数组只是复制了它的地址，如果要解决这种情况的话，我们就要采用深层复制<br />
          */<br />
     }<br />
 }</pre>
</div>
<p>深层clone()</p>
<div>
<pre class="prettyprint linenums"> package test;

 public class A implements Cloneable{<br />
         public String name[];<br />
         public A() {<br />
             name = new String[2];<br />
         }<br />
         public Object clone() {<br />
             A obj = null;<br />
             try {<br />
                 obj = (A) super.clone();<br />
                 obj.name=(String[])name.clone();//这是实现方式<br />
             } catch (CloneNotSupportedException e) {<br />
                 // TODO Auto-generated catch block<br />
                 e.printStackTrace();<br />
             }<br />
             return obj;<br />
         }

     public static void main(String[] args) {<br />
         // TODO Auto-generated method stub<br />
         A a1 = new A();<br />
         A a2 = new A();<br />
         a1.name[0]="a";<br />
         a1.name[1]="1";<br />
         a2=(A)a1.clone();<br />
         a2.name[0]="b";<br />
         a2.name[1]="1";<br />
         System.out.println("a1.name="+a1.name);<br />
         System.out.println("a1.name="+a1.name[0]+a1.name[1]);<br />
         System.out.println("a2.name="+a2.name);<br />
         System.out.println("a2.name="+a2.name[0]+a2.name[1]);<br />
         /*<br />
          * 结果：<br />
          *  a1.name=[Ljava.lang.String;@7852e922<br />
          *  a1.name=a1<br />
          *  a2.name=[Ljava.lang.String;@4e25154f<br />
          *  a2.name=b1<br />
          */<br />
         /*分析：<br />
          * 可以看到我们输出的a1.name=a1b1.name=b1,说明我们在复制对象的时候数组name的负责传递的不是地址，而是开辟了另外的一片储存空间，而不是两个引用指向同一片内存空间<br />
          *<br />
          */<br />
     }<br />
 }</pre>
</div>
<p>这就是深层复制，可是如果我们类的属性有Vector等储存对象地址的容器的时候，我们就必须进行彻底的clone()，栗子如下：</p>
<p>彻底clone()</p>
<div>
<pre class="prettyprint linenums"> package test;

 public class B implements Cloneable{<br />
     public String x="520";<br />
     public Object clone() {<br />
         B obj = null;<br />
         try {<br />
             obj = (B) super.clone();<br />
         } catch (CloneNotSupportedException e) {<br />
             // TODO Auto-generated catch block<br />
             e.printStackTrace();<br />
         }<br />
         return obj;<br />
     }<br />
 }

 package test;

 import java.util.Vector;<br />
 public class A implements Cloneable{<br />
         public String name[];<br />
         public Vector&lt;B&gt; clab;<br />
         public A() {<br />
             name = new String[2];<br />
             clab=new Vector&lt;B&gt;();<br />
         }<br />
         public Object clone() {<br />
             A obj = null;<br />
             try {<br />
                 obj = (A) super.clone();<br />
                 obj.name=(String[])name.clone();//这是实现方式<br />
                 obj.clab=new Vector&lt;B&gt;();<br />
                 for(int i=0;i&lt;clab.size();i++) {//彻底clone<br />
                     B temp = (B)clab.get(i).clone();//class B 也必须实现clone方法<br />
                     obj.clab.add(temp);<br />
                 }<br />
             } catch (CloneNotSupportedException e) {<br />
                 // TODO Auto-generated catch block<br />
                 e.printStackTrace();<br />
             }<br />
             return obj;<br />
         }

     public static void main(String[] args) {<br />
         // TODO Auto-generated method stub<br />
         A a1 = new A();<br />
         A a2 = new A();<br />
         B b1 = new B();<br />
         a1.name[0]="a";<br />
         a1.name[1]="1";<br />
         a1.clab.add(b1);

         a2=(A)a1.clone();

         System.out.println("a2.name="+a2.name);<br />
         System.out.println("a2.name="+a2.name[0]+a2.name[1]);<br />
         System.out.println(a2.clab.get(0).x);

         /*<br />
          * 结果：<br />
          *  a1.name=[Ljava.lang.String;@7852e922<br />
          *  a1.name=a1<br />
          *  520<br />
          */<br />
         /*分析：<br />
          * 如果类的属性里面有对象容器，那么必须采用彻底负责<br />
          */<br />
     }<br />
 }</pre>
</div>
<p>5.toString()</p>
<p>先看看文档对此的说明：</p>
<p>返回该对象的字符串表示。通常，<code>toString</code> 方法会返回一个&ldquo;以文本方式表示&rdquo;此对象的字符串。结果应是一个简明但易于读懂的信息表达式。建议所有子类都重写此方法。</p>
<p>总结一下就是返回这个对象的字符串表现形式</p>
<p>下面我们看看源码：</p>
<p>public String toString() {<br />&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; return getClass().getName() + "@" + Integer.toHexString(hashCode());<br />&nbsp;&nbsp;&nbsp; }</p>
<p>可以看到返回的字符串是由对象的名称和对象的hashcode组成的</p>
<p>6.finalize()</p>
<p>我们先来看一下文档对此的说明：</p>
<p>当垃圾回收器确定不存在对该对象的更多引用时，由对象的垃圾回收器调用此方法。子类重写 <code>finalize</code> 方法，以配置系统资源或执行其他清除。</p>
<p><tt>finalize</tt> 的常规协定是：当 Java<sup>TM</sup> 虚拟机已确定尚未终止的任何线程无法再通过任何方法访问此对象时，将调用此方法，除非由于准备终止的其他某个对象或类的终结操作执行了某个操作。<tt>finalize</tt> 方法可以采取任何操作，其中包括再次使此对象对其他线程可用；不过，<tt>finalize</tt> 的主要目的是在不可撤消地丢弃对象之前执行清除操作。例如，表示输入/输出连接的对象的 finalize 方法可执行显式 I/O 事务，以便在永久丢弃对象之前中断连接。</p>
<p><tt>Object</tt> 类的 <tt>finalize</tt> 方法执行非特殊性操作；它仅执行一些常规返回。<tt>Object</tt> 的子类可以重写此定义。</p>
<p>protected void finalize() throws Throwable { }<br />}</p>
<p>总结一下就是：当某个对象被Java虚拟机回收的时候执行这个方法，如果我们想在这个对象被回收的时候做点什么，比如再次使此对象对其他线程可用，那么就需要我们重写这个方法。</p>
<p>7.notify(),notifyAll()，wait()</p>
<p>这3个方法就是专为线程而生的，要实现线程的安全我们有synchronized，而这3个方法就为线程的同步而准备的</p>
<p>首先我们先来了解一下线程同步和线程互斥</p>
<p>线程同步：就是协调步调，一个任务，多个线程完成，线程的执行有先后顺序，这个就叫线程同步</p>
<p>线程互斥：A线程调用a资源的时候B线程就不能调用a资源，得等到A线程调用该资源结束之后，B线程才能调用资源a，这个就叫线程互斥</p>
<p>wait():如果对象调用了该方法，就会使持有该对象的进程把对象的控制器交出去，然后处于等待状态</p>
<p>notify():如果对象调用了该方法,就会随机通知某个正在等待该对象控制器的线程可以继续运行</p>
<p>notifyAll():如果对象调用了该方法,就会通知所有正在等待该对象控制器的线程可以继续运行</p>
<p>同时wait还可以指定等待的时间长度，如果是默认的话，就一直等待直到被通知</p>
<p>错误的地方，欢迎兄弟们拍砖！！！！！！！</p>
<p>大家一起交流一起进步</p>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1301290/201804/1301290-20180403150553765-1175451692.gif" /><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/1301290/201804/1301290-20180403150557240-378345874.jpg" /></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8kkpr78.html">SQL Server   Bulk Insert批量数据导入</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96l5jn9.html">Redis多机常用架构-sentinel</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r26deq.html">ORACLE 分组之后容易被忽略的bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pl1nyq.html">CentOS安装Hypernetes相关问题解法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8k34d3q.html">android Textview动态设置大小</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnd0xe8.html">SQL 表值函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x3zye8.html">phpmyadmin误删表后的恢复过程（心惊胆跳啊）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1v4zjq.html">The method getDispatcherType&lpar;&rpar; is undefined for the type HttpServletRequest 升级到tomcat8&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me7vo6q.html">mysql distinct field1&comma;field2&comma;field3&comma; &period;&period;&period;&period; from table</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zowpn1q.html">Vue js 的生命周期（看了就懂）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r4yl39.html">mpvue 解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnv313q.html">android - 调用系统分享功能分享图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwlrlkl9.html">转化Excel表格为php配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/8em30wz9.html">js 判断一个元素是否在滚动的可视区域内，不在就固定到可视区域的上方。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvepg2y9.html">企业服务的3种模式：On-Premise、SaaS、Mixed，该选哪种？--创业邦</a>
		</li>
						<li><a href="https://www.batexi.com/a/8emn3je9.html">NYOJ    1063   生活的烦恼    （二叉树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjovyp8.html">maven &plus; hessian 简单样例</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd14vg8.html">WPF绘制简单常用的Path（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qndne128.html">git忽略项gitegnore配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlovm20q.html">ng 服务</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/96pzr748.html">Robotium 框架学习之概述</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwj42v38.html">赢在面试之Java泛型篇&lpar;十二&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoewjvq.html">Python argparse模块实现模拟 linux 的ls命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/9507o7v8.html">NOIP2017-普及组复赛第2题 题解</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljp6o09.html">谷歌浏览器  插件安装配置Momentum chrome</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pd2lv49.html">TFboy养成记 CNN</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoemp3q.html">ios2048小游戏</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoe5zxq.html">Laravel框架使用的一些注意细节（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gern2z8.html">python中的&OpenCurlyDoubleQuote;&period;T&rdquo;操作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj2n0lq.html">一个PHP高性能、多并发、restful的工具库（基于multi&lowbar;curl）</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
